<template>
  <v-dialog v-model="dialogData" persistent max-width="600px">
    <v-form ref="form" v-model="valid" lazy-validation>
      <v-card>
        <v-card-title>
          <span class="text-h5">Thêm khách hàng</span>
        </v-card-title>
        <v-card-text>
          <v-container>
            <v-row>
              <v-col cols="12">
                <v-text-field
                  label="Tên"
                  outlined
                  dense
                  :rules="rules.customerName"
                  v-model="form.customerName"
                  @keydown.enter="onSave"
                ></v-text-field>
              </v-col>
              <v-col cols="12">
                <v-text-field
                  label="Email"
                  outlined
                  dense
                  :rules="rules.email"
                  v-model="form.email"
                  @keydown.enter="onSave"
                ></v-text-field>
              </v-col>
              <v-col cols="12">
                <v-text-field
                  outlined
                  label="Điện thoại"
                  :rules="rules.telNum"
                  v-model="form.telNum"
                  @keydown.enter="onSave"
                ></v-text-field>
              </v-col>
              <v-col cols="12">
                <v-text-field
                  outlined
                  label="Địa chỉ"
                  :rules="rules.address"
                  v-model="form.address"
                  @keydown.enter="onSave"
                ></v-text-field>
              </v-col>
              <v-col cols="12">
                <v-checkbox
                  v-model="isActive"
                  label="Trạng thái"
                  :value="1"
                ></v-checkbox>
              </v-col>
            </v-row>
          </v-container>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="blue-grey lighten-4" @click="onClose"> Hủy </v-btn>
          <v-btn color="red lighten-2 white--text" @click="onSave"> Lưu </v-btn>
        </v-card-actions>
      </v-card>
    </v-form>
  </v-dialog>
</template>

<script>
import customerService from "../../../services/customerService";

export default {
  props: {
    dialogData: {
      type: Boolean,
      required: true,
      default: false,
    },
  },
  data() {
    return {
      valid: false,
      form: {
        customerName: "",
        email: "",
        telNum: "",
        address: "",
        isActive: 1,
      },
      rules: {
        customerName: [
          (v) => {
            if (!v) return "Tên không được trống.";
            if (!!v && v.length < 5) return "Tên phải lớn hơn 5 ký tự.";
            return true;
          },
        ],
        email: [
          (v) => {
            if (!v) return "Email không được trống.";
            if (!!v && !/.+@.+\..+/.test(v))
              return "Email không đúng định dạng.";
            return true;
          },
        ],
        telNum: [
          (v) => {
            if (!v) return "Điện thoại không được để trống.";
            if (!/^([0-9\s\-\+\(\)]*)$/.test(v))
              return "Nhập không đúng định dạng điện thoại.";
            return true;
          },
        ],
        address: [
          (v) => {
            if (!v) return "Địa chỉ không được để trống.";
            return true;
          },
        ],
      },
    };
  },
  computed: {
    isActive: {
      get() {
        return this.form.isActive;
      },
      set(val) {
        this.form.isActive = Number(val);
      },
    },
  },
  methods: {
    onSave() {
      const isValid = this.$refs.form.validate();
      if (!isValid) return false;

      this.$store.commit("loading", true);
      customerService
        .add(this.form)
        .then((response) => {
          this.$store.commit("loading", false);
          this.$store.commit("showMessageSuccess", "Thêm thành công");
          this.onClose();
          this.$emit("onReloadList");
        })
        .catch((error) => {
          let msgError = "";
          if (error.response.status === 422) {
            const dataErrors = error.response.data.errors;
            let errors = [];
            for (const [key, value] of Object.entries(dataErrors)) {
              errors.push(value);
            }
            msgError = errors.toString();
          } else {
            msgError = error.response.data.message;
          }
          this.$store.commit("loading", false);
          this.$store.commit("showMessageError", msgError);
        });
    },
    onClose() {
      this.form = {
        customerName: "",
        email: "",
        telNum: "",
        address: "",
        isActive: 1,
      };
      this.$refs.form.reset();
      this.$emit("onChangeDialogData", false);
    },
  },
  created() {},
};
</script>
